#include <SPI.h>
#include <nRF24L01.h>
#include <RF24.h>
#include <RF24_config.h>
#include <stdio.h>
#include <stdlib.h>

// Variables de comunicacion USB
char cadEntrada[38];// Cadena para almacenar comando
char charEntrada=0;// caracter para leer comando
int limite= 37;
boolean hayDatos= false;

//Variables del brazo
int brazo[9];

//Variables para transmision inalambrica
RF24 radio(8,7); //Definicion de pines para CE y CSN
 // direcciones de pila para escritura y lectura
const uint64_t pipes[2] = { 0xF0F0F0F0E1LL, 0xF0F0F0F0D2LL }; 
int chequeo;
long milisAnterior =0;
long intervalo = 35;

//Variables para control
int potpin = 1;  // pin de conexion de joystick
int potpin2= 2;
int val;    // variable para leer joystick
int val2;

void setup(){
  for(int i=0;i<8;i++)
    brazo[i]=1500;
  chequeo=1;
  Serial.begin(115200);
  Serial.println("HELLO");
  radio.begin();
  radio.openWritingPipe(pipes[0]);
  radio.openReadingPipe(1,pipes[1]);
  radio.startListening();
}

void loop(){
  if(Serial.available()){ //
    int i=0;
    hayDatos=true;
    while(Serial.available()>0){
      if(i<limite){
        charEntrada=Serial.read();
        cadEntrada[i]=charEntrada;
        i++;
        cadEntrada[i]='\0';
      }
    }
  }
  delay(100);

  if(hayDatos){
    Serial.println("Si hay DAtos");
    Serial.println(cadEntrada);
    if(recorrerComando())
      for (int i=0;i<6;i++)
        Serial.println(brazo[i]);
  }
  
  //Lectura de valores de joystick
  val = analogRead(potpin);            // reads the value of the potentiometer (value between 0 and 1023) 
  val = map(val, 0, 1023, 1000, 2000);     // scale it to use it with the servo (value between 0 and 180) 
  val2 = analogRead(potpin2);
  val2 = map(val2, 0, 1023, 1000, 2000);
  brazo[6]=val;
  brazo[7]=val2;
  
  //Transmision inalambrica
  if (radio.available()){
    unsigned long milisActual = millis();
    if(milisActual - milisAnterior > intervalo){
      milisAnterior = milisActual;
      boolean done = false;
      while (!done){
        done = radio.read(&chequeo, sizeof(chequeo));
      }
    }
    radio.stopListening();
    boolean ok = radio.write(&brazo,sizeof(brazo));
    radio.startListening();
  }
  
}

boolean recorrerComando(){
    int i=0;
    while(hayDatos){
      char codigo;
      codigo=cadEntrada[i];
      Serial.println(codigo);
      int aux=0;
      switch(codigo){
        case 'A'://Servo Base
                aux=obtenerMilis(0,i+1);
                i=i+aux;
                break;
        case 'B'://Servo Hombro
                aux=obtenerMilis(1,i+1);
                i=i+aux;
                break;
        case 'C'://Servo Codo
                aux=obtenerMilis(2,i+1);
                i=i+aux;
                break;
        case 'D'://Servo Muneca F
                aux=obtenerMilis(3,i+1);
                i=i+aux;
                break;
        case 'E'://Servo Muneca G
                aux=obtenerMilis(4,i+1);
                i=i+aux;
                break;
        case 'F'://Servo Pinza
                aux=obtenerMilis(5,i+1);
                i=i+aux;
                break;
        default:
                hayDatos=false;
      }i++;
    }
  //  hayDatos=false;
    return true;
}
//Obatener entero de la cadena
int obtenerMilis(int servo,int j){
  char temp[6]={"\0"};
  int aux=0;
  while(cadEntrada[j]>47 && cadEntrada[j]<58){
    temp[aux]=cadEntrada[j];
    aux++;j++;
  }
  temp[aux]='\0';
  brazo[servo]=atol(temp);
  return aux;
}

